﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WinGridLINQToObjects
{
    public partial class Form1 : Form
    {
        List<User> Users;
        List<Location> Locations;

        #region Constructor

        public Form1()
        {
            InitializeComponent();
        }

        #endregion

        #region Form1_Load

        private void Form1_Load(object sender, EventArgs e)
        {
            Location here = new Location(1, "Here");
            Location there = new Location(2, "There");
            Location somewhere = new Location(3, "Somewhere");
            Location everywhere = new Location(4, "Everywhere");
            Location elsewhere = new Location(5, "Elsewhere");
            Location nowhere = new Location(6, "Nowhere");

            User joe = new User(100, "Joe", "Smith", 1);
            User mike = new User(101, "Mike", "Hanlon", 2);
            User alicia = new User(102, "Alicia", "Singer", 3);
            User harry = new User(103, "Harry", "Chan", 4);
            User sara = new User(104, "Sara", "Hopkins", 5);
            User mary = new User(105, "Mary", "Hendrickson", 6);

            Users = new List<User> {joe, mike, alicia, harry, sara, mary};
            Locations = new List<Location> { here, there, somewhere, everywhere, elsewhere, nowhere };

            var query = from user in Users
                        join location in Locations on user.IDLocation equals location.ID
                        select new { id = user.ID, firstname = user.FirstName, lastname = user.LastName, idloc = user.IDLocation, locname = location.Name };

            this.bindingSource1.DataSource = query;
            this.ultraGrid1.DataSource = this.bindingSource1;
        }

        #endregion

        #region ultraGrid1_InitializeLayout

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {

        }

        #endregion

        #region Public Class User

        public class User
        {
            #region Constructors

            public User()
            {
            }

            public User(int Id, string firstName, string lastName, int idLocation)
            {
                ID = Id;
                FirstName = firstName;
                LastName = lastName;
                IDLocation = idLocation;
                //Location = location;
            }

            #endregion

            #region Properties

            public int ID { get; set; }
            public string FirstName { get; set; }
            public string LastName { get; set; }
            public int IDLocation { get; set; }
            //public Location Location { get; set; }

            #endregion
        }

        #endregion

        #region Public Class Location

        public class Location
        {
            #region Constructors

            public Location()
            {
            }

            public Location(int iD, string name)
            {
                ID = iD;
                Name = name;
            }

            #endregion

            #region Properties

            public int ID { get; set; }
            public string Name { get; set; }

            #endregion
        }

        #endregion
    }
}
